#ifndef TESTING_LEVEL2S
#define TESTING_LEVEL2S

// === CSRMV =====================================================
#if defined (CSRMV)
#define DIM3
// target routine
#if defined (MUBLAS)
#define ROUTINE_TARGET(th,m,n,nnz,al,dscA,A,Aptr,Aind,X,bt,Y) MUBLAS_CSRMV(&mh,th.tranA,m,n,nnz,&al,A,Aptr,Aind,X,&bt,Y)
#elif defined (CUBLAS)
#define ROUTINE_TARGET(th,m,n,nnz,al,dscA,A,Aptr,Aind,X,bt,Y) CUBLAS_CSRMV(ch,cusparse_trans_const_m(th.tranA),m,n,nnz,&al,dscA,A,Aptr,Aind,X,&bt,Y)
#endif
// reference routine
#if   defined (CHECK_MPACK)
#elif defined (CHECK_CBLAS)
#elif defined (CHECK_CUBLAS)
#define ROUTINE_REFERENCE(th,m,n,nnz,al,dscA,A,Aptr,Aind,X,bt,Y) CUBLAS_CSRMV(ch,cusparse_trans_const_m(th.tranA),m,n,nnz,&al,dscA,A,Aptr,Aind,X,&bt,Y)
#endif
// %%%
#define ROUTINE_FLOPS(m,n,k)					(FPMADCOUNT*k+2*FPMULCOUNT*m+FPADDCOUNT*m)
#define ROUTINE_BYTES(m,n,k,s)					((k+2*m+n)*s) 
#define ROUTINE_MAXSIZE(gmem,margin,s)			(sqrt((gmem-margin)/s))
#define ROUTINE_MAXSIZE_1(gmem,margin,s,dim1)	((gmem-margin)/s/dim1)*0 // !!!
#define ROUTINE_MAXSIZE_2(gmem,margin,s,dim1,dim2)	((gmem-margin)/s+dim1/dim2)*0 // !!!
#endif
// ==============================================================

#endif
